/* R[h͂rihr sR[h͂bqke */
/* $Id$ */

#include "stdafx.h"
#include "utvideo.h"
#include "Predict.h"
#include "TunedFunc.h"

void cpp_PredictCylindricalWrongMedianAndCount(uint8_t *pDst, const uint8_t *pSrcBegin, const uint8_t *pSrcEnd, size_t cbStride, uint32_t pCountTable[][256])
{
	const uint8_t *p = pSrcBegin;
	uint8_t *q = pDst;

	// ŏ̃C̍ŏ̃sNZ 0x80 \ĂB
	*q = *p - 0x80;
	pCountTable[0][*q]++;
	p++;
	q++;

	// ŏ̃C̎c̃sNZ predict left ƓB
	for (; p < pSrcBegin + cbStride; p++, q++)
	{
		*q = *p - *(p - 1);
		pCountTable[0][*q]++;
	}

	// 1 CȂꍇ͂ŏIB
	if (p == pSrcEnd)
		return;

	// ̃C̍ŏ̃sNZ predict aboveB
	// ĂƃAZuɏ኱ȒPɂȂB
	*q = *p - *(p - cbStride);
	pCountTable[0][*q]++;
	p++;
	q++;

	// c̃sNZ predict median ̖{
	for (; p < pSrcEnd; p++, q++)
	{
		*q = *p - median<uint8_t>(*(p - cbStride), *(p - 1), *(p - cbStride) + *(p - 1) - *(p - 1 - cbStride));
		pCountTable[0][*q]++;
	}
}

void cpp_RestoreCylindricalWrongMedian(uint8_t *pDst, const uint8_t *pSrcBegin, const uint8_t *pSrcEnd, size_t cbStride)
{
	const uint8_t *p = pSrcBegin;
	uint8_t *q = pDst;

	*q++ = *p++ + 0x80;

	for (; p < pSrcBegin + cbStride; p++, q++)
	{
		*q = *p + *(q - 1);
	}

	if (p == pSrcEnd)
		return;

	*q = *p + *(q - cbStride);
	p++;
	q++;

	for (; p < pSrcEnd; p++, q++)
	{
		*q = *p + median<uint8_t>(*(q - cbStride), *(q - 1), *(q - cbStride) + *(q - 1) - *(q - 1 - cbStride));
	}
}


template<int B>
void cpp_PredictCylindricalLeftAndCount(symbol_t<B> *pDst, const symbol_t<B> *pSrcBegin, const symbol_t<B> *pSrcEnd, uint32_t pCountTable[][1 << B])
{
	const symbol_t<B> *p = pSrcBegin;
	symbol_t<B> *q = pDst;

	*q = (*p - CSymbolBits<B>::midval) & CSymbolBits<B>::maskval;
	pCountTable[0][*q]++;
	p++;
	q++;

	// c̃sNZ predict left ̖{
	for (; p < pSrcEnd; p++, q++)
	{
		*q = (*p - *(p-1)) & CSymbolBits<B>::maskval;
		pCountTable[0][*q]++;
	}
}

template void cpp_PredictCylindricalLeftAndCount<8>(symbol_t<8> *pDst, const symbol_t<8> *pSrcBegin, const symbol_t<8> *pSrcEnd, uint32_t pCountTable[][256]);
template void cpp_PredictCylindricalLeftAndCount<10>(symbol_t<10> *pDst, const symbol_t<10> *pSrcBegin, const symbol_t<10> *pSrcEnd, uint32_t pCountTable[][1024]);


template<int B>
void cpp_RestoreCylindricalLeft(symbol_t<B> *pDst, const symbol_t<B> *pSrcBegin, const symbol_t<B> *pSrcEnd)
{
	const symbol_t<B> *p = pSrcBegin;
	symbol_t<B> *q = pDst;

	*q = (*p + CSymbolBits<B>::midval) & CSymbolBits<B>::maskval;
	p++;
	q++;

	// c̃sNZ predict left ̖{
	for (; p < pSrcEnd; p++, q++)
	{
		*q = (*(q - 1) + *p) & CSymbolBits<B>::maskval;
	}
}

template void cpp_RestoreCylindricalLeft<8>(symbol_t<8> *pDst, const symbol_t<8> *pSrcBegin, const symbol_t<8> *pSrcEnd);
template void cpp_RestoreCylindricalLeft<10>(symbol_t<10> *pDst, const symbol_t<10> *pSrcBegin, const symbol_t<10> *pSrcEnd);


template<int B, bool DoCount>
static inline void cpp_PredictPlanarGradientAndMayCount(symbol_t<B> *pDst, const symbol_t<B> *pSrcBegin, const symbol_t<B> *pSrcEnd, size_t cbStride, uint32_t pCountTable[][1 << B])
{
	const uint8_t *p = pSrcBegin;
	uint8_t *q = pDst;

	*q = (*p - CSymbolBits<B>::midval) & CSymbolBits<B>::maskval;
	if (DoCount)
		pCountTable[0][*q]++;
	p++;
	q++;

	for (; p < pSrcBegin + cbStride; p++, q++)
	{
		*q = (*p - *(p - 1)) & CSymbolBits<B>::maskval;
		if (DoCount)
			pCountTable[0][*q]++;
	}

	for (auto pp = pSrcBegin + cbStride; pp != pSrcEnd; pp += cbStride)
	{
		*q = (*p - *(p - cbStride)) & CSymbolBits<B>::maskval;
		if (DoCount)
			pCountTable[0][*q]++;
		p++;
		q++;

		for (; p < pp + cbStride; p++, q++)
		{
			*q = (*p - (*(p - cbStride) + *(p - 1) - *(p - 1 - cbStride))) & CSymbolBits<B>::maskval;
			if (DoCount)
				pCountTable[0][*q]++;
		}
	}
}

template<int B>
void cpp_PredictPlanarGradientAndCount(symbol_t<B> *pDst, const symbol_t<B> *pSrcBegin, const symbol_t<B> *pSrcEnd, size_t cbStride, uint32_t pCountTable[][1 << B])
{
	cpp_PredictPlanarGradientAndMayCount<B, true>(pDst, pSrcBegin, pSrcEnd, cbStride, pCountTable);
}

template<int B>
void cpp_PredictPlanarGradient(symbol_t<B> *pDst, const symbol_t<B> *pSrcBegin, const symbol_t<B> *pSrcEnd, size_t cbStride)
{
	cpp_PredictPlanarGradientAndMayCount<B, false>(pDst, pSrcBegin, pSrcEnd, cbStride, NULL);
}

template void cpp_PredictPlanarGradientAndCount<8>(symbol_t<8> *pDst, const symbol_t<8> *pSrcBegin, const symbol_t<8> *pSrcEnd, size_t cbStride, uint32_t pCountTable[][256]);
template void cpp_PredictPlanarGradient<8>(symbol_t<8> *pDst, const symbol_t<8> *pSrcBegin, const symbol_t<8> *pSrcEnd, size_t cbStride);


template<int B>
void cpp_RestorePlanarGradient(symbol_t<B> *pDst, const symbol_t<B> *pSrcBegin, const symbol_t<B> *pSrcEnd, size_t cbStride)
{
	const uint8_t *p = pSrcBegin;
	uint8_t *q = pDst;

	*q = (*p + CSymbolBits<B>::midval) & CSymbolBits<B>::maskval;
	p++;
	q++;

	for (; p < pSrcBegin + cbStride; p++, q++)
	{
		*q = (*p + *(q - 1)) & CSymbolBits<B>::maskval;
	}

	for (auto pp = pSrcBegin + cbStride; pp != pSrcEnd; pp += cbStride)
	{
		*q = (*p + *(q - cbStride)) & CSymbolBits<B>::maskval;
		p++;
		q++;

		for (; p < pp + cbStride; p++, q++)
		{
			*q = (*p + (*(q - cbStride) + *(q - 1) - *(q - 1 - cbStride))) & CSymbolBits<B>::maskval;
		}
	}
}

template void cpp_RestorePlanarGradient<8>(symbol_t<8> *pDst, const symbol_t<8> *pSrcBegin, const symbol_t<8> *pSrcEnd, size_t cbStride);
